// animace.cpp : Defines the entry point for the console application.
//
#include <math.h>
#include <GL/glut.h>

GLfloat LightPosition1[] = {0, 5.0, 20}; // pozice svetla svetla
GLfloat LightAmbient[] = {1.0, 1.0, 1.0, 1.0}; // ambientni slozka svetla
GLfloat LightDiffuse[] = {1.0, 1.0, 1.0, 1.0}; // difuzni slozka svetla
GLfloat LightSpecular[]= {1.0, 1.0, 1.0, 1.0}; // specularni slozka svetla

// nastaveni materialu - gold
GLfloat MatAmb1[]= {0.247250, 0.199500, 0.074500, 1.0}; // ambientni slozka materialu
GLfloat MatDif1[]={0.751640, 0.606480, 0.226480, 1.0}; // difuzni slozka material
GLfloat MatSpe1[]={0.628281, 0.555802, 0.366065, 1.0}; // specularni slozka materialu
GLfloat MatShi1 = 51.2;

// nastaveni materialu - chrome
GLfloat MatAmb2[]= {0.25, 0.25, 0.25, 1.0}; // ambientni slozka materialu
GLfloat MatDif2[]={0.4, 0.4, 0.4, 1.0}; // difuzni slozka material
GLfloat MatSpe2[]={0.774597, 0.774597, 0.774597, 1.0}; // specularni slozka materialu
GLfloat MatShi2 = 76.8;

// nastaveni materialu - polished copper
GLfloat MatAmb3[]= {0.2295, 0.08825, 0.0275, 1.0}; // ambientni slozka materialu
GLfloat MatDif3[]={0.5508, 0.2118, 0.066, 1.0}; // difuzni slozka material
GLfloat MatSpe3[]={0.580594, 0.223257, 0.0695701, 1.0}; // specularni slozka materialu
GLfloat MatShi3 = 51.2;

int angle = 0; // pro pohyb pro kruznici
float x = 0, z = -3; //pohyb po trojuhelnikove draze
float px = -4, pz; // pohyb koule po exponenciale
int plus = 1; // kterym smerem se koule pohybuje po draze
int cubeAngle = 0; // uhel pro natoceni v rozich trojuhelniku

int scene = 0; /* pro prepinani mezi scenami 
			    * 0 - pouze pohyb teles
				* 1 - rotace kolem stredu sceny
				* 2 - sledovani konvicky
			   */

const float PI = 3.1415926535897932384626433832795;
const float degree = PI / 180;
GLfloat fromx = 25, fromy = 0, fromz = 0; // odkud se divam
GLfloat rotAngle = PI / 2; // uhel pro rotaci kolem sceny
int move = 1;



void changeSize(int w1, int h1)	{

	float ratio;

	// Prevent a divide by zero, when window is too short
	// (you cant make a window of zero width).
	if(h1 == 0)
		h1 = 1;

	ratio = 1.0f * w1 / h1;
	// Reset the coordinate system before modifying
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	
	// Set the viewport to be the entire window
    glViewport(0, 0, w1, h1	);

	// Set the clipping volume
	gluPerspective(45, ratio, 1, 1000);

	// setting the camera now
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();	
}


// vyvola akci vybranou v menu
void menuProcess(int option) {

	switch(option) {
	case 0:
		scene = 0;
		move = 1;
		glutPostRedisplay();
		break;
	case 1:		
		rotAngle = 0;
		scene = 1;
		move = 0;
		glutPostRedisplay();		
		break;
	case 2:		
		scene = 2;
		rotAngle = PI / 2;
		move = 1;
		glutPostRedisplay();
		break;
	case 3:		
		scene = 3;
		rotAngle = angle * PI / 180;
		move = 1;
		glutPostRedisplay();
		break;	
	case 4:
		exit(0);
	}
}



// vytvori menu
void makeMenu(void) {	

	glutCreateMenu(menuProcess);
	glutAddMenuEntry("Pouze pohyb tles", 0);
	glutAddMenuEntry("Rotace kolem stedu bez pohybu tles", 1);
	glutAddMenuEntry("Rotace kolem stedu s pohybem tles", 2);
	glutAddMenuEntry("Sleduj konviku", 3);
	glutAddMenuEntry("Exit", 4);
	glutAttachMenu(GLUT_RIGHT_BUTTON);
}


void init() {

	glMatrixMode(GL_PROJECTION);
	gluPerspective(45, 0.75, 1, 1000);	
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	gluLookAt(0, 5, 20, 0, 0, 0, 0.0, 1.0, 0.0);

	glClearColor(0.0, 0.0, 0.0, 1.0);
	glShadeModel(GL_SMOOTH);
	glEnable(GL_DEPTH_TEST);
	
	makeMenu();	
}


void display() {

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);		
	
	glLoadIdentity();

	switch(scene) {
	case 0: 
		gluLookAt(0.0, 0.0, 20.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);	
		break;
	case 1: 		
	case 2:
		fromx = 25*cos(rotAngle);
		fromz = 25*sin(rotAngle);
		rotAngle += degree;
		if(rotAngle >=2*PI) {
			rotAngle = 0;
		}	

		gluLookAt(fromx, 0.0, fromz, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
		break;
	case 3:
		fromx = 12*cos(rotAngle);
		fromz = -12*sin(rotAngle);
		rotAngle += degree;
		if(rotAngle >=2*PI) {
			rotAngle = 0;
		}	
		if(angle == 0) {
			rotAngle = 0;
		}
		gluLookAt(fromx, 0.0, fromz, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
		break;
	}	
	
	//nastaveni svetla	
	glLightfv(GL_LIGHT1, GL_POSITION, LightPosition1);
	glLightfv(GL_LIGHT1, GL_AMBIENT, LightAmbient);
	glLightfv(GL_LIGHT1, GL_DIFFUSE, LightDiffuse);	
	glLightfv(GL_LIGHT1, GL_SPECULAR, LightSpecular);
	
	glEnable(GL_LIGHTING); //zapnuti osvetleni	
	glEnable(GL_LIGHT1);

	//nastaveni materialu
	glMaterialfv(GL_FRONT, GL_DIFFUSE, MatDif1);
	glMaterialfv(GL_FRONT, GL_AMBIENT, MatAmb1);	
	glMaterialfv(GL_FRONT, GL_SPECULAR, MatAmb1);
	glMaterialf(GL_FRONT, GL_SHININESS, MatShi1);

	glPushMatrix();
	if(move==1) {
		glRotatef(angle++, 0, 1, 0);
		if(angle >= 360) {
			angle = 0;
		}	
	}
	glTranslatef(7, 0, 0);
	glutSolidTeapot(1);
	glPopMatrix();

	//nastaveni materialu
	glMaterialfv(GL_FRONT, GL_DIFFUSE, MatDif2);
	glMaterialfv(GL_FRONT, GL_AMBIENT, MatAmb2);	
	glMaterialfv(GL_FRONT, GL_SPECULAR, MatAmb2);
	glMaterialf(GL_FRONT, GL_SHININESS, MatShi2);

	glPushMatrix();	
	if(move==1) {
		glTranslatef(x, 5, z);	
		if(cubeAngle >= 180) {
			cubeAngle = 0;
		}
		if((z >= -3) & (x >= -11) & (x < 10)) { // pohyb doprava
			if(cubeAngle != 0) {
				cubeAngle++;
			}else {
				x += 0.1;
			}
		}else {		
			if(x >= 10) {	
				cubeAngle++;;
				if(cubeAngle == 45) {
					z -= 0.1;
					x -= 0.1;
				}
			}else {
				if(x >= 0) { //pohyb doleva dozadu				
					x -= 0.1;
					z -= 0.1;				
				}else { //pohyb doleva dopredu				
					if(cubeAngle < 135) {
						cubeAngle++;
					}else {
						x -= 0.1;
						z += 0.1;
					}
				}
			}
		}
		glRotatef(cubeAngle, 0, 1, 0); // natoceni krychle	
	}
	glutSolidCube(2);
	glPopMatrix();

	//nastaveni materialu
	glMaterialfv(GL_FRONT, GL_DIFFUSE, MatDif3);
	glMaterialfv(GL_FRONT, GL_AMBIENT, MatAmb3);	
	glMaterialfv(GL_FRONT, GL_SPECULAR, MatAmb3);
	glMaterialf(GL_FRONT, GL_SHININESS, MatShi3);

	if(move==1) {
		glPushMatrix();
		if(plus == 1) {
			px += 0.1;		
		}else {
			px -= 0.1;
		}
		if(px >= 4) {
			plus = -1;
		}	
		if(px <= -4) {
			plus = 1;
		}
			pz = -exp(px);
		glTranslatef(px, -5, pz);
	}
	glutSolidSphere(1, 16, 16);
	glPopMatrix();

	glutSwapBuffers();
}


void keyboard(unsigned char key, int x, int y) {
	switch(key) {
	case 27:
		exit(0);
	}
}


int main(int argc, char* argv[]) {

	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);	
	glutInit(&argc, argv);
	
	glutInitWindowPosition(0,0);
	glutInitWindowSize(640,480);				
	glClearColor(0.0, 0.0, 0.0, 1.0);	
	glutCreateWindow("Animace");							

	init();	

	glutKeyboardFunc(keyboard);
	glutIdleFunc(display);
	glutDisplayFunc(display);
	glutReshapeFunc(changeSize);		

	glutMainLoop();	
	
	return 0;

}